/*
 * include/asm-microblaze/asm.h -- Macros for writing assembly code
 *
 *  Copyright (C) 2003       John Williams <jwilliams@itee.uq.edu.au>
 *  Copyright (C) 2001,2002  NEC Corporation
 *  Copyright (C) 2001,2002  Miles Bader <miles@gnu.org>
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of this
 * archive for more details.
 *
 * Written by Miles Bader <miles@gnu.org>
 * Microblaze port by John Williams
 */
 
 #include <linux/config.h>
 #include <asm/xparameters.h>

#define G_ENTRY(name)							      \
   .align 4;								      \
   .globl name;								      \
   .type  name,@function;						      \
   name
#define END(name)							      \
   .size  name,.-name

#define L_ENTRY(name)							      \
   .align 4;								      \
   .type  name,@function;						      \
   name

/* Convert between virtual and physical address for MMU.  */
#ifdef NO_MM
#define	TOPHYS(addr)  addr
#define tophys(rd,rs) addik rd,rs,0
#define tovirt(rd,rs) addik rd,rs,0
#else
#define TOPHYS(addr)  (addr+RAM_BASEADDR-CONFIG_KERNEL_START)
#define tophys(rd,rs) addik rd,rs,(RAM_BASEADDR-CONFIG_KERNEL_START)
#define tovirt(rd,rs) addik rd,rs,(CONFIG_KERNEL_START-RAM_BASEADDR)
#endif

/* to compile with old assembler */
#define rPID 0x1000
#define rZPR 0x1001
#define rTLBX 0x1002
#define rTLBLO 0x1003
#define rTLBHI 0x1004
#define rTLBSX 0x1005

#define MTS(spr, gpr) .long (0x9400C000 | gpr<<16 | spr)
#define MFS(gpr, spr) .long (0x94008000 | gpr<<21 | spr)
